_TEXT	ENDS
_DATA	SEGMENT

chipinit dw	NONE_init

SVGA_init dw	NONE_init		;  0 No Chip
	dw	VESA_init		;  1 VESA SuperVGA
	dw	ATI_init		;  2 ATI Technologies SuperVGA
	dw	AHEADA_init		;  3 AHEAD A SuperVGA
	dw	AHEADB_init		;  4 AHEAD B SuperVGA
	dw	CHIPS_init		;  5 Chips & Technologies SuperVGA
	dw	EVEREX_init		;  6 Everex SuperVGA
	dw	GENOA_init		;  7 Genoa Systems SuperVGA
	dw	OAK_init		;  8 OAK Technologies SuperVGA
	dw	PARADISE_init		;  9 Paradise SuperVGA
	dw	TRIDENT88_init		; 10 Trident 8800 SuperVGA
	dw	TRIDENT89_init		; 11 Trident 8900 SuperVGA
	dw	VIDEO7_init		; 12 Video7 SuperVGA
	dw	ET3000_init		; 13 Tseng Labs ET3000 SuperVGA
	dw	ET4000_init		; 14 Tseng Labs ET4000 SuperVGA
	dw	NCR_init		; 15 NCR 77C22E SuperVGA
	dw	S3_init			; 16 S3 SuperVGA
	dw	ACUMOS_init		; 17 AcuMos SuperVGA
	dw	AL2101_init		; 18 AL2101 SuperVGA
	dw	MXIC_init		; 19 MXIC SuperVGA
	dw	P2000_init		; 20 P2000 SuperVGA
	dw	RT3106_init		; 21 RT3106 SuperVGA
	dw	CIRRUS_init		; 22 Cirrus 5422 SuperVGA
	dw	CIRRUSA_init		; 23 Cirrus 5426 SuperVGA
	dw	CHIPS452_init		; 24 Chips & Technologies SuperVGA
	dw	CHIPS453_init		; 25 Chips & Technologies SuperVGA
	dw	PARADISEP_init		; 26 Paradise PVGA SuperVGA
	dw	OAK87_init		; 27 OAK Technologies (OTI87) SuperVGA
	dw	TRIDENTCL_init		; 28 Trident 8900CL SuperVGA
	dw	ET4000W32_init		; 29 Tseng Labs ET4000W32 SuperVGA
	dw	NONE_init		; 30
	dw	NONE_init		; 31

chipterm dw	NONE_term

SVGA_term dw	NONE_term		;  0 No Chip
	dw	VESA_term		;  1 VESA SuperVGA
	dw	ATI_term		;  2 ATI Technologies SuperVGA
	dw	AHEADA_term		;  3 AHEAD A SuperVGA
	dw	AHEADB_term		;  4 AHEAD B SuperVGA
	dw	CHIPS_term		;  5 Chips & Technologies SuperVGA
	dw	EVEREX_term		;  6 Everex SuperVGA
	dw	GENOA_term		;  7 Genoa Systems SuperVGA
	dw	OAK_term		;  8 OAK Technologies SuperVGA
	dw	PARADISE_term		;  9 Paradise SuperVGA
	dw	TRIDENT88_term		; 10 Trident 8800 SuperVGA
	dw	TRIDENT89_term		; 11 Trident 8900 SuperVGA
	dw	VIDEO7_term		; 12 Video7 SuperVGA
	dw	ET3000_term		; 13 Tseng Labs ET3000 SuperVGA
	dw	ET4000_term		; 14 Tseng Labs ET4000 SuperVGA
	dw	NCR_term		; 15 NCR 77C22E SuperVGA
	dw	S3_term			; 16 S3 SuperVGA
	dw	ACUMOS_term		; 17 AcuMos SuperVGA
	dw	AL2101_term		; 18 AL2101 SuperVGA
	dw	MXIC_term		; 19 MXIC SuperVGA
	dw	P2000_term		; 20 P2000 SuperVGA
	dw	RT3106_term		; 21 RT3106 SuperVGA
	dw	CIRRUS_term		; 22 Cirrus 5422 SuperVGA
	dw	CIRRUSA_term		; 23 Cirrus 5426 SuperVGA
	dw	CHIPS452_term		; 24 Chips & Technologies SuperVGA
	dw	CHIPS453_term		; 25 Chips & Technologies SuperVGA
	dw	PARADISEP_term		; 26 Paradise PVGA SuperVGA
	dw	OAK87_term		; 27 OAK Technologies (OTI87) SuperVGA
	dw	TRIDENTCL_term		; 28 Trident 8900CL SuperVGA
	dw	ET4000W32_term		; 29 Tseng Labs ET4000W32 SuperVGA
	dw	NONE_term		; 30
	dw	NONE_term		; 31

_DATA	ENDS
_TEXT	SEGMENT

setchip	PROC	near

NONE_init:				;  0 No Chip
NONE_term:
EVEREX_init:				;  6 Everex SuperVGA (NONE)
EVEREX_term:
GENOA_init:				;  7 Genoa Systems SuperVGA (NONE)
GENOA_term:
TRIDENT88_init:				; 10 Trident 8800 SuperVGA
TRIDENT88_term:
ET4000_init:				; 14 Tseng Labs ET4000 SuperVGA
ET4000_term:
ET4000W32_init:				; 29 Tseng Labs ET4000W32 SuperVGA
ET4000W32_term:
S3_init:				; 16 S3 SuperVGA
S3_term:
P2000_init:				; 20 P2000 SuperVGA
P2000_term:
	ret

info	dw	128 DUP (0)

VESA_init:				;  1 VESA SuperVGA
	push	es
	push	di
;
	mov	ax,OFFSET nobank	; default routine
	mov	VesaSwitch,ax
	mov	ax,SEG    nobank
	mov	VesaSwitch+2,ax
;
	mov	ax,04F01H
	mov	cx,__GrBiosMode
	mov	di,SEG    info
	mov	es,di
	mov	di,OFFSET info
	int	10H
	cmp	ax,0004FH
	jne	VESA_no
	mov	ax,cs:info+12		; VESA routine
	mov	VesaSwitch,ax
	mov	ax,cs:info+12+2
	mov	VesaSwitch+2,ax
VESA_no:
	pop	di
	pop	es
	ret
VESA_term:
	ret

ATI_init:				;  2 ATI Technologies SuperVGA
        modinx  1CEh, 0BEh, 01000b, 01000b      ; Enable dual bank mode
	ret
ATI_term:
        modinx  1CEh, 0BEh, 01000b, 0           ; Disable dual bank mode
	ret

AHEADA_init:				;  3 AHEAD A SuperVGA (NONE)
AHEADB_init:				;  4 AHEAD B SuperVGA
        modinx  3CEh, 0Fh, 20h, 20h ; Enable extended registers
        modinx  3CEh, 0Ch, 20h, 20h ; Enable enhanced mode
	ret
AHEADA_term:
AHEADB_term:
        modinx  3CEh, 0Fh, 20h, 0h  ; Disable extended registers
        modinx  3CEh, 0Ch, 20h, 0h  ; Disable enhanced mode
	ret

CHIPS_init:				;  5 Chips & Technologies SuperVGA
CHIPS452_init:
CHIPS453_init:
        outp    46E8h, 1Eh          ; Place chip in setup mode
        outp    103h, 80h           ; Enable extended registers
        outp    46E8h, 0Eh          ; Bring chip out of setup mode
	modinx  3D6h, 4, 4, 4       ; Enable bank access and extended CRTC
	modinx  3D6h, 0Bh, 3, 1     ; Enable extended paging
	wrinx	3D6h, 0Ch, 0		; Zero extended start address
	ret
CHIPS_term:
CHIPS452_term:
CHIPS453_term:
        outp    46E8h, 1Eh          ; Place chip in setup mode
        outp    103h, 0             ; Disable extended registers
        outp    46E8h, 0Eh          ; Bring chip out of setup mode
        ret

OAK_init:				;  8 OAK Technologies SuperVGA (NONE)
OAK87_init:
        modinx  3CEh, 0Dh, 1Ch, 0Ch     ; Enable access to memory above 256k
	ret
OAK_term:
OAK87_term:
	ret

PARADISE_init:				;  9 Paradise SuperVGA
        wrinx   3CEh, 0Fh, 5        ; Turn off write protect on VGA registers
        wrinx   3C4h, 6h, 48h       ; Unlock extended sequencer regs
	wrinx   3D4h, 29h, 85h      ; Turn on access to PR10-17
	modinx	3D4h, 2Fh, 62h, 0	; Disable standard VGA memory
        modinx  3CEh, 0Bh, 8, 8     ; Enable both PROA and PROB
        modinx  3C4h, 11h, 80h, 80h ; Set PROA for read, PROB for write
	ret
PARADISEP_init:
	wrinx   3CEh, 0Fh, 5        ; Turn off write protect on VGA registers
	wrinx   3D4h, 29h, 85h      ; Turn on access to PR10-17
	ret
PARADISE_term:
PARADISEP_term:
        modinx  3CEh, 0Bh, 8, 0     ; Disable PROB
	wrinx   3CEh, 0Fh, 0        ; Turn on write protect on VGA registers
	ret

TRIDENT89_init:				; 11 Trident 8900 SuperVGA
TRIDENTCL_init:
	modinx  3CEh, 6, 4, 4       ; Set pagesize to 64k
	modinx	CRTC, 1Eh, 80h, 80h	; Enable display of second 512k
	ret
TRIDENT89_term:
TRIDENTCL_term:
	ret

VIDEO7_init:				; 12 Video7 SuperVGA
        outp    3C4h, 6, 0EAh       ; Enable extended registers
	ret
VIDEO7_term:
        outp    3C4h, 6, 0AEh       ; Disable extended registers
	ret

ET3000_init:				; 13 Tseng Labs ET3000 SuperVGA
        modinx  3C4h, 4, 2, 2       ; Enable access to all video memory
	ret
ET3000_term:
	ret

NCR_init:				; 15 NCR 77C22E SuperVGA
        wrinx   3C4h, 5, 5          ; Enable extended registers
        wrinx   3C4h, 18h, 0
        wrinx   3C4h, 19h, 0
        wrinx   3C4h, 1Ah, 0
        wrinx   3C4h, 1Bh, 0
        wrinx   3C4h, 1Dh, 0
        wrinx   3C4h, 1Ch, 0
        modinx  3C4h, 1Eh, 011100b, 011100b
	ret
NCR_term:
        wrinx   3C4h, 5, 0          ; Disable extended registers
	ret

ACUMOS_init:				; 17 AcuMos SuperVGA
        wrinx   3C4h, 6, 12h        ; Enable extended registers
        modinx  3D4h, 1Bh, 10b, 10b ; Enable access to upper memory
	ret
ACUMOS_term:
        wrinx   3C4h, 6, 0          ; Disable extended registers
	ret

AL2101_init:				; 18 AL2101 SuperVGA
        modinx  CRTC, 1Ah, 10h, 10h             ; Enable extensions
        modinx  CRTC, 19h, 2, 2                 ; Enable > 256k
        modinx  3CEh, 0Fh, 4, 4                 ; Enable Read/Write banks
        modinx  CRTC, 20h, 7, 0                 ; Clear display start
	ret
AL2101_term:
        modinx  CRTC, 1Ah, 10h, 0h              ; Disable extensions
	ret

MXIC_init:				; 19 MXIC SuperVGA
        modinx  3C4h, 065h, 040h, 040h  ; Enable access to registers
        wrinx   3C4h, 0A7h, 087h        ; Enable extended registers
        modinx  3C4h, 0C3h, 4, 4        ; Enable banking operation
        modinx  3C4h, 0F0h, 8, 8        ; Enable extended CRT addressing
	ret
MXIC_term:
        wrinx   3C4h, 0A7h, 0       ; Disable extended registers
	ret

RT3106_init:				; 21 RT3106 SuperVGA
        modinx  CRTC, 019h, 0A0h, 0A0h  ; Enable display from upper 512k
        modinx  3CEh, 0Fh, 4, 4         ; Setup for dual banking mode
	ret
RT3106_term:
        modinx  3CEh, 0Fh, 4, 0 ; Return to single bank mode
	ret

CIRRUS_init:				; 22 Cirrus 5422 SuperVGA
	wrinx   3C4h, 6, 12h        ; Enable extended registers
        modinx  3D4h, 1Bh, 10b, 10b ; Enable access to upper memory
	ret
CIRRUS_term:				; 22 Cirrus 5422 SuperVGA
	modinx  3CEh, 0Bh, 20h, 00h ; Disable 16k bank mode
	ret

CIRRUSA_init:				; 23 Cirrus 5426 SuperVGA
	wrinx   3C4h, 6, 12h        ; Enable extended registers
	modinx  3D4h, 1Bh, 10b, 10b ; Enable access to upper memory
	modinx	3C4h, 0Fh, 80h, 80h	; Enable access beyond 1Mb
	modinx	3CEh, 0Bh, 20h, 20h	; Enable 16k bank mode
	ret
CIRRUSA_term:				; 23 Cirrus 5426 SuperVGA
	modinx  3CEh, 0Bh, 20h, 00h ; Disable 16k bank mode
	ret

setchip	ENDP
